https://codeforces.com/contest/1238/problem/E
E. Keyboard Purchase
time limit per test
1 second
memory limit per test
256 megabytes
input
standard input
output
standard output
You have a password which you often type — a string ss of length nn. Every character of this string is one of the first mm lowercase Latin letters.
Since you spend a lot of time typing it, you want to buy a new keyboard.
A keyboard is a permutation of the first mm Latin letters. For example, if m=3m=3, then there are six possible keyboards: abc, acb, bac, bca, cab and cba.
Since you type your password with one finger, you need to spend time moving your finger from one password character to the next. The time to move from character sisi to character si+1si+1 is equal to the distance between these characters on keyboard. The total time you have to spend typing the password with a keyboard is called the slowness of this keyboard.
More formaly, the slowness of keyboard is equal to ∑i=2n|possi−1−possi|∑i=2n|possi−1−possi|, where posxposx is position of letter xx in keyboard.
For example, if ss is aacabc and the keyboard is bac, then the total time of typing this password is |posa−posa|+|posa−posc|+|posc−posa|+|posa−posb|+|posb−posc||posa−posa|+|posa−posc|+|posc−posa|+|posa−posb|+|posb−posc| = |2−2|+|2−3|+|3−2|+|2−1|+|1−3||2−2|+|2−3|+|3−2|+|2−1|+|1−3| = 0+1+1+1+2=50+1+1+1+2=5.
Before buying a new keyboard you want to know the minimum possible slowness that the keyboard can have.
Input
The first line contains two integers nn and mm (1≤n≤105,1≤m≤201≤n≤105,1≤m≤20).
The second line contains the string ss consisting of nn characters. Each character is one of the first mm Latin letters (lowercase).
Output
Print one integer – the minimum slowness a keyboard can have.
Examples
input
Copy
6 3
aacabc
output
Copy
5
input
Copy
6 4
aaaaaa
output
Copy
0
input
Copy
15 4
abacabadabacaba
output
Copy
16
Note
The first test case is considered in the statement.
In the second test case the slowness of any keyboard is 00.
In the third test case one of the most suitable keyboards is bacd.
思路:开始想到状压DP,但是不论前面的字母先怎么取,前面的顺序会影响到后面的值。参考了网上大量答案,其实dp应该记录的是:当前取的字母之间的贡献值+当前已取字母在下一位将要取的位置时 与还没有取的字母 的贡献值 最小值。这样消除了后效性!!(因为还没有取得字母在右边某个位置,可以先计算出左边以蛆字母与右边未取字母在当前位的贡献值)
可以记录所取字母到下一位将要取的值的位置 的贡献值。减少重复计算,时间复杂度O(m*2^m).
O(m^2 * 2^m).
import java.util.*;
import java.io.*;
public class Main {
public static void main(String args[]) {new Main().run();}
FastReader in = new FastReader();
PrintWriter out = new PrintWriter(System.out);
void run(){
out.println(work());
out.flush();
}
long mod=1000000007;
long gcd(long a,long b) {
return b==0?a:gcd(b,a%b);
}
long work() {
int n=in.nextInt();
int m=in.nextInt();
String str=in.next();
long[] dp=new long[1<<m];
long[][] cnt=new long[m][m];
for(int i=1;i<n;i++) {
int n1=str.charAt(i-1)-'a';
int n2=str.charAt(i)-'a';
cnt[n1][n2]++;
cnt[n2][n1]++;
}
for(int i=1;i<1<<m;i++) {
dp[i]=9999999999L;
long v=0;
for(int j=0;j<m;j++) {
if((i&(1<<j))>0) {//第j个字母
for(int k=0;k<m;k++) {
if((i&(1<<k))==0) {
v+=cnt[j][k];
}
}
}
}
for(int j=0;j<m;j++) {
if((i&(1<<j))>0) {
dp[i]=Math.min(dp[i], dp[i-(1<<j)]+v);
}
}
}
return dp[(1<<m)-1];
}
}
class FastReader
{
BufferedReader br;
StringTokenizer st;
public FastReader()
{
br=new BufferedReader(new InputStreamReader(System.in));
}
public String next()
{
if(st==null || !st.hasMoreElements())
{
try {
st = new StringTokenizer(br.readLine());
} catch (IOException e) {
e.printStackTrace();
}
}
return st.nextToken();
}
public int nextInt()
{
return Integer.parseInt(next());
}
public long nextLong()
{
return Long.parseLong(next());
}
}
O(m * 2^m).
import java.util.*;
import java.io.*;
public class Main {
public static void main(String args[]) {new Main().run();}
FastReader in = new FastReader();
PrintWriter out = new PrintWriter(System.out);
void run(){
out.println(work());
out.flush();
}
long mod=1000000007;
long gcd(long a,long b) {
return b==0?a:gcd(b,a%b);
}
long work() {
int n=in.nextInt();
int m=in.nextInt();
String str=in.next();
long[] dp=new long[1<<m];
long[][] cnt=new long[m][m];
long[] rec=new long[1<<m];//记录每次移动的一位怎加的值,减少重复计算
for(int i=1;i<n;i++) {
int n1=str.charAt(i-1)-'a';
int n2=str.charAt(i)-'a';
cnt[n1][n2]++;
cnt[n2][n1]++;
}
for(int i=1;i<1<<m;i++) {
dp[i]=9999999999L;
long v=0;
int b=0;//最低位的1
for(int j=0;j<m;j++) {
if((i&(1<<j))>0) {
b=j;
break;
}
}
for(int j=0;j<m;j++) {
if((i&(1<<j))==0) {
v+=cnt[b][j];
}else {
if(b!=j)v-=cnt[b][j];
}
}
v+=rec[i-(1<<b)];
for(int j=0;j<m;j++) {
if((i&(1<<j))>0) {
dp[i]=Math.min(dp[i], dp[i-(1<<j)]+v);
}
}
rec[i]=v;
}
return dp[(1<<m)-1];
}
}
class FastReader
{
BufferedReader br;
StringTokenizer st;
public FastReader()
{
br=new BufferedReader(new InputStreamReader(System.in));
}
public String next()
{
if(st==null || !st.hasMoreElements())
{
try {
st = new StringTokenizer(br.readLine());
} catch (IOException e) {
e.printStackTrace();
}
}
return st.nextToken();
}
public int nextInt()
{
return Integer.parseInt(next());
}
public long nextLong()
{
return Long.parseLong(next());
}
}